local _ARTG = _Avyr_Raid_Tools_ADDON_Globals
local Widgets = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Widgets")
local Loc = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Localisation")
local BorderSize, Padding = Widgets.BorderSize, Widgets.Padding;
local insert = table.insert

local Prefix = "AvyrRaidTools"
local Coms = CreateFrame("FRAME",nil,UIParent)

local WindowContentWidth = 200


local ByteConversionTable = {
    "0","1","2","3","4","5","6","7","8","9",
    "A","B","C","D","E","F","G","H","I","K","L","M","N","O","P","Q","R","S","T","V","X","Y","Z"
}
local CharConversionTable 
Coms.StringConverter = function(Action,...)
    if Action == "Compress" then 
        local charString = tostring(...)
        local byteString = ""
        for character in charString:gmatch(".") do
            local byte = strbyte(character)
            local SecByte = floor(byte/getn(ByteConversionTable))
            byteString = byteString.. ByteConversionTable[SecByte + 1] .. ByteConversionTable[byte - SecByte*getn(ByteConversionTable) + 1]
        end 
        return byteString
    elseif Action == "Decompress" then 
        if not CharConversionTable then 
            CharConversionTable = {}
            for i,v in ipairs(ByteConversionTable) do 
                CharConversionTable[v] = i - 1
            end 
        end 
        local byteString = ...
        local PlainTextString = ""
        local PrevByte 
        for byte in byteString:gmatch(".") do 
            if CharConversionTable[byte] then 
                if PrevByte then 
                    PlainTextString = PlainTextString .. strchar(CharConversionTable[PrevByte]*getn(ByteConversionTable) + CharConversionTable[byte])
                    PrevByte = nil
                else 
                    PrevByte = byte
                end 
            end
        end 
        return PlainTextString
    elseif Action == "CompressNote" then 
        local Name,Description,Data,Expansion,Raid,Boss = ...
        local ExportString = Coms.StringConverter("Compress",Name).."a"..Coms.StringConverter("Compress",Description).."a"
        ExportString = ExportString..Coms.StringConverter("Compress",Expansion).."a"..Coms.StringConverter("Compress",Raid).."a"..Coms.StringConverter("Compress",Boss).."a"
        if Data then 
            local firstline = true
            for i,v in ipairs(Data) do
                if v[1] and v[2] then 
                    if firstline then 
                        firstline = false
                    else
                        ExportString = ExportString.."b"
                    end 
                    ExportString = ExportString .. Coms.StringConverter("Compress",v[1]).."c"..Coms.StringConverter("Compress",v[2])
                end 
            end 
        end 
        return ExportString
    elseif Action == "DecompressNote" then 
        local Name,Description,Expansion,Raid,Boss,Data = strsplit("a",...)
        Name = Coms.StringConverter("Decompress",Name)
        Description = Coms.StringConverter("Decompress",Description)
        Expansion = Coms.StringConverter("Decompress",Expansion)
        Raid = Coms.StringConverter("Decompress",Raid)
        Boss = Coms.StringConverter("Decompress",Boss)
        local DataClone 
        if Data ~= "" then 
            DataClone = {}
            for i,v in ipairs({strsplit("b",Data)}) do 
                local Header,Note = strsplit("c",v)
                insert(DataClone,{Coms.StringConverter("Decompress",Header),Coms.StringConverter("Decompress",Note)})
            end 
        end 
        return Name,Description,DataClone,Expansion,Raid,Boss
    end 
end 

local IW,IH = 500,500
Coms.ImportNote = function()
    local Window = _ARTG:ComponentWindow(Loc:Translation("IMPORT_NOTE"))

    Window["Imprt_TextBox"] = Widgets:CreateBasicTextBox(Window, true, "LEFT")
    Window["Imprt_TextBox"]:SetPoint("BOTTOMLEFT", BorderSize + Padding, BorderSize + Padding)
    Window["Imprt_TextBox"]:Size(IW - 2*BorderSize - 2*Padding,IH - 2*BorderSize - 3*Padding - Window.Header:GetHeight())
    Window["Imprt_TextBox"]:SetValue("")
    Window["Imprt_TextBox"].OnValueChanged = function(self,value)
        _ARTG:ComponentWindow()
        Coms.Load("Finished",value)
    end

    Window:Size(IW,IH)
end 

Coms.ExportNote = function(Name,Description,Data,Expansion,Raid,Boss)
    local Window = _ARTG:ComponentWindow(Loc:Translation("EXPORT_NOTE"))

    local ExportString = Coms.StringConverter("CompressNote",Name,Description,Data,Expansion,Raid,Boss)

    Window["Export_TextBox"] = Widgets:CreateBasicTextBox(Window, true, "LEFT")
    Window["Export_TextBox"]:SetPoint("BOTTOMLEFT", BorderSize + Padding, BorderSize + Padding)
    Window["Export_TextBox"]:Size(IW - 2*BorderSize - 2*Padding,IH - 2*BorderSize - 3*Padding - Window.Header:GetHeight())
    Window["Export_TextBox"]:SetValue(ExportString)
    Window["Export_TextBox"].OnValueChanged = function(self,value)
        self:SetValue(ExportString)
    end

    Window:Size(IW,IH)
end 

local function filterFunc(_, event, msg, player, l, cs, t, flag, channelId, ...)
    if flag == "GM" or flag == "DEV" then
        return
    end
    local newMsg = "";
    local remaining = msg;
    local done;
    repeat
        local start, finish, SenderName, SenderRealm, Expansion, Raid, Boss, NoteIndex, NoteName = remaining:find("%[AvyrRaidTools: (%C+)%-(%C+) %- (%d+).(%d+).(%d+).(%d+) %- (.*)%]")
        if SenderName and NoteIndex then
            newMsg = newMsg..remaining:sub(1, start-1)
            newMsg = newMsg.."|HAvyrRaidTools:"..Expansion..":"..Raid..":"..Boss..":"..NoteIndex..":"..SenderName..":"..SenderRealm..":"..NoteName.."|h|cffffd100[".."|r|cffffd100ART: "..SenderName.." - "..NoteName.."]|h|r"
            remaining = remaining:sub(finish + 1)
        else
            done = true;
        end
    until(done)
    if newMsg ~= "" then
        return false, newMsg, player, l, cs, t, flag, channelId, ...;
    end
end
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", filterFunc)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER", filterFunc)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", filterFunc)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY_LEADER", filterFunc)
ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", filterFunc)

--additional channels that could be helpful 
ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", filterFunc) --only for debugging
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", filterFunc)
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", filterFunc)
ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", filterFunc)
ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER", filterFunc)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER", filterFunc)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER_INFORM", filterFunc)

--not really needed here (notes for lfr? why!)
--ChatFrame_AddMessageEventFilter("CHAT_MSG_INSTANCE_CHAT", filterFunc)
--ChatFrame_AddMessageEventFilter("CHAT_MSG_INSTANCE_CHAT_LEADER", filterFunc)

local function RequestNote(Link)
    local _,_,Expansion,Raid,Boss,NoteIndex,SenderName,SenderRealm,NoteName = Link:find("AvyrRaidTools:(%d+):(%d+):(%d+):(%d+):(%C+):(%C+):(.*)",0)
    NoteIndex = tonumber(NoteIndex)
    if Expansion and Raid and Boss and NoteIndex and SenderName and SenderRealm and NoteName then 
        local Success = C_ChatInfo.SendAddonMessage(Prefix, "REQUEST:"..Expansion..":"..Raid..":"..Boss..":"..NoteIndex..":"..NoteName , "WHISPER", SenderName.."-"..SenderRealm)
        if Success then 
            Coms.Load("Buffering")
        end 
    end 
end 

local OSetItemRef = SetItemRef
function SetItemRef(Link, ...)
    if Link and Link:find("AvyrRaidTools") == 1 then
        return RequestNote(Link)
    end 
    return OSetItemRef(Link, ...);
end

local IncomingString = ""
Coms.Load = function(Action,...)
    if Action == "Buffering" then 
        local Window = _ARTG:ComponentWindow(Loc:Translation("NOTE_REQUESTED"))
        local Height = Window.Header:GetHeight() + BorderSize + 2*Padding

        Height = Height + BorderSize
    
        Window:Size(WindowContentWidth + 2*Padding + 2*BorderSize, Height)
    elseif Action == "Incoming" then
        local PartType,Note = ...

        local Window = _ARTG:ComponentWindow(Loc:Translation("LOADING_NOTE_WAITING"))
        local Height = Window.Header:GetHeight() + BorderSize + 2*Padding
    
        Window.CopyChatStringLB = Widgets:FetchFontString(Window)
        Window.CopyChatStringLB:SetText("...")
        Window.CopyChatStringLB:SetWidth(WindowContentWidth)
        Window.CopyChatStringLB:SetHeight(20 - Padding)
        Window.CopyChatStringLB:SetPoint("TOPLEFT",Padding + BorderSize,-Height)
        Widgets:SetThemedColor(Window.CopyChatStringLB,"Highlight")
        Height = Height + 20 - Padding

        Height = Height + BorderSize
    
        Window:Size(WindowContentWidth + 2*Padding + 2*BorderSize, Height)

		if PartType == "0" then 
			IncomingString = Note
		elseif PartType == "1" then 
            IncomingString = IncomingString..Note
		elseif PartType == "2" then 
            IncomingString = IncomingString..Note
            Coms.Load("Finished",IncomingString)
            IncomingString = ""
		end 
    elseif Action == "Finished" then
        local Note = ...
        local Name,Description,Data,Expansion,Raid,Boss = Coms.StringConverter("DecompressNote",Note)
        
        local LoadString = Name.. ""
        Expansion = tonumber(Expansion)
        LoadString = LoadString.."\n".._ARTG.DataFuncs.GetRaidInfo("exp.data.name",Expansion)
        Raid = tonumber(Raid)
        LoadString = LoadString.."\n".._ARTG.DataFuncs.GetRaidInfo("raid.data.name",RaidID,Expansion)
        Boss = tonumber(Boss)
        LoadString = LoadString.."\n".._ARTG.DataFuncs.GetRaidInfo("boss.data.name",BossID,RaidID,Expansion)

        local Window = _ARTG:ComponentWindow(Loc:Translation("NEW_NOTE"))
        local Height = Window.Header:GetHeight() + BorderSize + 2*Padding

        Window.CopyChatStringLB = Widgets:FetchFontString(Window)
        Window.CopyChatStringLB:SetText(LoadString)
        Window.CopyChatStringLB:SetWidth(WindowContentWidth)
        Window.CopyChatStringLB:SetHeight(64 - Padding)
        Window.CopyChatStringLB:SetPoint("TOPLEFT",Padding + BorderSize,-Height)
        Widgets:SetThemedColor(Window.CopyChatStringLB,"Highlight")
        Height = Height + 64 - Padding

        Window.LoadBtn = Widgets:CreateButton(Window)
        Window.LoadBtn:SetPoint("TOPLEFT",Padding + BorderSize,-Height)
        Window.LoadBtn:Size(WindowContentWidth,20)
        Window.LoadBtn:SetText(Loc:Translation("LOAD"),nil,"Highlight")
        Window.LoadBtn.OnClick = function()
            _ARTG:ComponentWindow()
            _ARTG.SV.SaveVariable("CurrentNote",{
                Name = Name, Description = Description,
                Expansion = Expansion, Raid = Raid, Boss = Boss,
                Data = Data
            })
        end 
        Height = Height + 20 + Padding
    
        Window.LoadBtn = Widgets:CreateButton(Window)
        Window.LoadBtn:SetPoint("TOPLEFT",Padding + BorderSize,-Height)
        Window.LoadBtn:Size(WindowContentWidth,20)
        Window.LoadBtn:SetText(Loc:Translation("SAVE_ONLY"),nil,"Highlight")
        Window.LoadBtn.OnClick = function()
            _ARTG:ComponentWindow()
            _ARTG.Editor:EditNote("New",Name,Description,Data,Expansion,Raid,Boss)
        end 
        Height = Height + 20 + Padding
    
        Window.LoadBtn = Widgets:CreateButton(Window)
        Window.LoadBtn:SetPoint("TOPLEFT",Padding + BorderSize,-Height)
        Window.LoadBtn:Size(WindowContentWidth,20)
        Window.LoadBtn:SetText(Loc:Translation("SAVE_AND_LOAD"),nil,"Highlight")
        Window.LoadBtn.OnClick = function()
            _ARTG:ComponentWindow()
            _ARTG.Editor:EditNote("New",Name,Description,Data,Expansion,Raid,Boss)
            _ARTG.SV.SaveVariable("CurrentNote",{
                Name = Name, Description = Description,
                Expansion = Expansion, Raid = Raid, Boss = Boss,
                Data = Data
            })
        end 
        Height = Height + 20 + Padding
        Height = Height + BorderSize
    
        Window:Size(WindowContentWidth + 2*Padding + 2*BorderSize, Height)
    end 
end 

Coms.Send = function(Action,...)
    if Action == "Prepare" then 
        local Name,Expansion,Raid,Boss,Index = ...
        local Window = _ARTG:ComponentWindow(Loc:Translation("SEND_NOTE"))
    
        local Height = Window.Header:GetHeight() + BorderSize + 2*Padding
    
        Window.CopyChatStringLB = Widgets:FetchFontString(Window)
        Window.CopyChatStringLB:SetText(Loc:Translation("CHAT_LINK_COPY_PASTE"))
        Window.CopyChatStringLB:SetWidth(WindowContentWidth)
        Window.CopyChatStringLB:SetHeight(20 - Padding)
        Window.CopyChatStringLB:SetJustifyH("LEFT")
        Window.CopyChatStringLB:SetJustifyV("BOTTOM")
        Window.CopyChatStringLB:SetPoint("TOPLEFT",Padding + BorderSize,-Height)
        Widgets:SetThemedColor(Window.CopyChatStringLB,"Highlight")
        Height = Height + 20 - Padding

        --|Hlinktype:linkstring|hLinktext|h 
        local PName,Realm = UnitFullName("player")
        local ExpansionShort = "0"
        local RaidShort = "0"
        local BossShort = "0"
        if type(Expansion) == "number" then ExpansionShort = Expansion end 
        if type(Raid) == "number" then RaidShort = Raid end 
        if type(Boss) == "number" then BossShort = Boss end 
        local Link =  "[AvyrRaidTools: "..PName .. "-" ..Realm.." - "..ExpansionShort.."."..RaidShort.."."..BossShort.."."..(Index or "0").." - "..Name.."]"
        Window.CopyChatString = Widgets:CreateBasicTextBox(Window, false, "LEFT")
        Window.CopyChatString:SetPoint("TOPLEFT",Padding + BorderSize,-Height)
        Window.CopyChatString:Size(WindowContentWidth,20)
        Window.CopyChatString:SetValue(Link)
        Window.CopyChatString.OnValueChanged = function(self,value)
            self:SetValue(Link)
        end
        Height = Height + 20 + Padding + 10

        Window.PartySendBtn = Widgets:CreateButton(Window)
        Window.PartySendBtn:SetPoint("TOPLEFT",Padding + BorderSize,-Height)
        Window.PartySendBtn:Size(WindowContentWidth,20)
        Window.PartySendBtn:SetText(Loc:Translation("SEND_LINK_TO_PARTY_CHAT"),nil,"Highlight")
        Window.PartySendBtn.OnClick = function()
            Window:Release()
            Window = nil
            SendChatMessage(Link,"PARTY")
        end 
        Height = Height + 20 + Padding

        Window.RaidSendBtn = Widgets:CreateButton(Window)
        Window.RaidSendBtn:SetPoint("TOPLEFT",Padding + BorderSize,-Height)
        Window.RaidSendBtn:Size(WindowContentWidth,20)
        Window.RaidSendBtn:SetText(Loc:Translation("SEND_LINK_TO_RAID_CHAT"),nil,"Highlight")
        Window.RaidSendBtn.OnClick = function()
            Window:Release()
            Window = nil
            SendChatMessage(Link,"RAID")
        end 
        Height = Height + 20 + Padding

        Height = Height + BorderSize

        Window:Size(WindowContentWidth + 2*Padding + 2*BorderSize, Height)
    elseif Action == "Send" then 
        local Sender,Note,Expansion,Raid,Boss = ...
        local ExportString = Coms.StringConverter("CompressNote",Note.Name,Note.Description,Note.Data,Expansion,Raid,Boss)
        if strlen(ExportString) > 253 then
            local TotalParts = ceil(strlen(ExportString)/253)
            for Parts = 1,TotalParts do 
                local PartialExportString = string.sub(ExportString,1 + 253*(Parts - 1),253*Parts)
				local PartType = "1"
				if Parts == 1 then PartType = "0" elseif Parts == TotalParts then PartType = "2" end
                C_ChatInfo.SendAddonMessage(Prefix,PartType..":"..PartialExportString,"WHISPER",Sender)
            end 
			--[[
            if strlen(ExportString)/251 < 10 then
                --1 251
                --252 502
                --503 753
                for Parts = 1,TotalParts do 
                    local PartialExportString = string.sub(ExportString,(250*(Parts - 1) + Parts),251*Parts)
                    C_ChatInfo.SendAddonMessage(Prefix,Parts..":"..TotalParts..":"..PartialExportString,"WHISPER",Sender)
                end 
            elseif strlen(ExportString)/249 < 100 then 
                local TotalParts = ceil(strlen(ExportString)/249)
                for Parts = 1,TotalParts do 
                    local PartialExportString = string.sub(ExportString,(248*(Parts - 1) + Parts),249*Parts)
                    C_ChatInfo.SendAddonMessage(Prefix,Parts..":"..TotalParts..":"..PartialExportString,"WHISPER",Sender)
                end 
            else
                print("Note too long to send")
            end ]]
            --split note into parts and send 
        else 
            C_ChatInfo.SendAddonMessage(Prefix,"3:"..ExportString,"WHISPER",Sender)
        end 
    end 
end 

Coms:SetScript("OnEvent",function(self,Event,MsgPrefix, msg, channel, sender, target, zoneChannelID, localID, name, instanceID)
    if MsgPrefix == Prefix then 
        if Event == "CHAT_MSG_ADDON" then --requests and stuff
            local Action,arg1,arg2,arg3,arg4,arg5 = strsplit(":",msg)
            if Action == "REQUEST" then 
                local Expansion = tonumber(arg1)
                local Raid = tonumber(arg2)
                local Boss = tonumber(arg3) 
                local Index = tonumber(arg4)
                if Expansion then 
                    if Expansion ~= 0 then 
                        if Raid ~= 0 then 
                            if Boss ~= 0 then 
                                if AvyrRaidTools_DB.Notes[Expansion] and AvyrRaidTools_DB.Notes[Expansion][Raid] and AvyrRaidTools_DB.Notes[Expansion][Raid][Boss] and 
                                AvyrRaidTools_DB.Notes[Expansion][Raid][Boss][Index] and AvyrRaidTools_DB.Notes[Expansion][Raid][Boss][Index].Name == arg5 then 
                                    Coms.Send("Send",sender,AvyrRaidTools_DB.Notes[Expansion][Raid][Boss][Index],Expansion,Raid,Boss)
                                end 
                            else 
                                if AvyrRaidTools_DB.Notes[Expansion] and AvyrRaidTools_DB.Notes[Expansion][Raid] and AvyrRaidTools_DB.Notes[Expansion][Raid]["Other"] and 
                                AvyrRaidTools_DB.Notes[Expansion][Raid]["Other"][Index] and AvyrRaidTools_DB.Notes[Expansion][Raid]["Other"][Index].Name == arg5 then 
                                    Coms.Send("Send",sender,AvyrRaidTools_DB.Notes[Expansion][Raid]["Other"][Index],Expansion,Raid,"Other")
                                end 
                            end 
                        else 
                            if AvyrRaidTools_DB.Notes[Expansion] and AvyrRaidTools_DB.Notes[Expansion]["Other"] and 
                            AvyrRaidTools_DB.Notes[Expansion]["Other"][Index] and AvyrRaidTools_DB.Notes[Expansion]["Other"][Index].Name == arg5 then 
                                Coms.Send("Send",sender,AvyrRaidTools_DB.Notes[Expansion]["Other"][Index],Expansion,"Other")
                            end 
                        end 
                    else 
                        if AvyrRaidTools_DB.Notes["Other"] and AvyrRaidTools_DB.Notes["Other"][Index] and AvyrRaidTools_DB.Notes["Other"][Index].Name == arg5 then 
                            Coms.Send("Send",sender,AvyrRaidTools_DB.Notes["Other"][Index],"Other")
                        end 
                    end 
                end 
            elseif Action == "0" or Action == "1" or Action == "2" then 
                Coms.Load("Incoming",Action,arg1)
			elseif Action == "3" then 
				Coms.Load("Finishing",arg1)
            end 
        elseif Event == "CHAT_MSG_ADDON_LOGGED" then --Receiving a note 
            --print(msg)
        end 
    end 
end)
Coms:RegisterEvent("CHAT_MSG_ADDON_LOGGED")
Coms:RegisterEvent("CHAT_MSG_ADDON")
C_ChatInfo.RegisterAddonMessagePrefix(Prefix)

_ARTG.Coms = Coms
