local Widgets = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Widgets")
local Loc = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Localisation")
local _ARTG = _Avyr_Raid_Tools_ADDON_Globals
local BorderSize, Padding = Widgets.BorderSize, Widgets.Padding;
local wipe, insert = table.wipe, table.insert

local Display = {}
_ARTG.NoteDisplay = Display

local NoteDisplayWindow
local CurrentNote = {}
local LoadedNoteData = {}
local CurrentIndex
local NextIndex

_ARTG.SV.RegisterSVCallback(function(varName,varValue)
	if varName == "ALL" or varName == "G_Enable" or varName == "G_LoadConditions" or varName == "CurrentNote" or varName == "ND_Enable" then 
		_ARTG.NoteDisplay:Load()   
	end 
	
	if varName == "ALL" or varName == "ND_PosX" or varName == "ND_PosY" or varName == "ND_Scale" or varName == "ND_Locked" then 
		_ARTG.NoteDisplay:UpdatePosition()
	end 
	
	if varName == "ALL" or varName == "ND_Width" or varName == "ND_Height" then 
		_ARTG.NoteDisplay:UpdateDimensions()
	end 
	
	if varName == "ALL" or varName == "ND_Backdrop" or varName == "ND_Backdropr" or varName == "ND_Backdropg" or varName == "ND_Backdropb" or varName == "ND_Backdropa" 
		or varName == "ND_NoteFontr" or varName == "ND_NoteFontg" or varName == "ND_NoteFontb" or varName == "ND_NoteFonta" 
		or varName == "ND_ConditionFontr" or varName == "ND_ConditionFontg" or varName == "ND_ConditionFontb" or varName == "ND_ConditionFonta" 
		or varName == "ND_HighlightCurrent" or varName == "ND_HighlightCurrentr" or varName == "ND_HighlightCurrentg" or varName == "ND_HighlightCurrentb" or varName == "ND_HighlightCurrenta" 
		or varName == "ND_HighlightNext" or varName == "ND_HighlightNextr" or varName == "ND_HighlightNextg" or varName == "ND_HighlightNextb" or varName == "ND_HighlightNexta" 
	then 
		_ARTG.NoteDisplay:UpdateColors()
	end 
	
	if varName == "ALL" or varName == "ND_EnableKeywords" or varName == "ND_KeywordsBorderHighlight" or varName == "ND_KeywordsBorderHighlightr" or 
		varName == "ND_KeywordsBorderHighlightg" or varName == "ND_KeywordsBorderHighlightb" or varName == "ND_KeywordsBorderHighlighta" or 
		varName == "ND_HideEntriesWithoutKeywords" or varName == "ND_KeywordsFontHighlight" or varName == "ND_KeywordsFontHighlightr" or 
		varName == "ND_KeywordsFontHighlightg" or varName == "ND_KeywordsFontHighlightb" or varName == "ND_KeywordsFontHighlighta" then 
		_ARTG.NoteDisplay:UpdateKeywords()
	end 
end,"ALL","G_Enable","CurrentNote","ND_Enable",
	"G_LoadConditions",
	"ND_PosX","ND_PosY","ND_Scale","ND_Locked","ND_Width","ND_Height",
	"ND_Backdrop","ND_Backdropr","ND_Backdropg","ND_Backdropb","ND_Backdropa",
	"ND_NoteFontr","ND_NoteFontg","ND_NoteFontb","ND_NoteFonta",
	"ND_ConditionFontr","ND_ConditionFontg","ND_ConditionFontb","ND_ConditionFonta",
	"ND_HighlightCurrent","ND_HighlightCurrentr","ND_HighlightCurrentg","ND_HighlightCurrentb","ND_HighlightCurrenta",
	"ND_HighlightNext","ND_HighlightNextr","ND_HighlightNextg","ND_HighlightNextb","ND_HighlightNexta",
	"ND_EnableKeywords","ND_KeywordsBorderHighlight","ND_KeywordsBorderHighlightr", 
	"ND_KeywordsBorderHighlightg","ND_KeywordsBorderHighlightb","ND_KeywordsBorderHighlighta",
	"ND_HideEntriesWithoutKeywords","ND_KeywordsFontHighlight","ND_KeywordsFontHighlightr", 
	"ND_KeywordsFontHighlightg","ND_KeywordsFontHighlightb","ND_KeywordsFontHighlighta"
)

function Display:GetWindow()
	return NoteDisplayWindow
end 

Display.Load = function(self) --setup the frames and events
	if not NoteDisplayWindow then 
		NoteDisplayWindow = Widgets:CreateFrame(Parent)   
		NoteDisplayWindow:SetClampedToScreen(true)
		NoteDisplayWindow:MakeMovable(true)
		NoteDisplayWindow.OnMove = function(self)
			local _, _, _, x, y = self:GetPoint(1)
			_ARTG.SV.SaveVariable("ND_PosX", x*NoteDisplayWindow:GetEffectiveScale(), true)
			_ARTG.SV.SaveVariable("ND_PosY", y*NoteDisplayWindow:GetEffectiveScale())
		end
	
		NoteDisplayWindow.ScrollFrame = Widgets:CreateScrollFrame(NoteDisplayWindow)
		NoteDisplayWindow.ScrollFrame:SetPoint("BOTTOMLEFT",Padding,Padding)
		NoteDisplayWindow.ScrollFrame:SetPoint("TOPRIGHT",-Padding,-Padding)
	
		NoteDisplayWindow.Content = Widgets:CreateFrame(NoteDisplayWindow.ScrollFrame)
		NoteDisplayWindow.Content:SetPoint("TOPLEFT")
		NoteDisplayWindow.Content:Size(600, 100)
		NoteDisplayWindow.ScrollFrame:SetScrollChild(NoteDisplayWindow.Content)
	
		NoteDisplayWindow:SetScript("OnMouseWheel",
		function(_, delta)
			--if not Display.CombatLock then 
				local ScrollMulti = NoteDisplayWindow.Content:GetHeight()/10
				if ScrollMulti > NoteDisplayWindow.ScrollFrame:GetHeight() - 2 * BorderSize then 
					ScrollMulti = NoteDisplayWindow.ScrollFrame:GetHeight() - 2 * BorderSize
				end
				local ScrollOffset = NoteDisplayWindow.ScrollFrame:GetVerticalScroll() - ScrollMulti * delta
				local ContentHeight = NoteDisplayWindow.Content:GetHeight()
				if ScrollOffset < 0 then 
					ScrollOffset = 0
				end 
				if ContentHeight < NoteDisplayWindow.ScrollFrame:GetHeight() - 2*BorderSize then 
					ScrollOffset = 0
				elseif ScrollOffset > ContentHeight - (NoteDisplayWindow.ScrollFrame:GetHeight() - 2*BorderSize) then 
					ScrollOffset = ContentHeight - (NoteDisplayWindow.ScrollFrame:GetHeight() - 2*BorderSize)
				end 
	
				NoteDisplayWindow.ScrollFrame:SetVerticalScroll(ScrollOffset)
			--end
		end)
	
		Display:UpdatePosition()
	end 
	Display:UpdateDimensions()
	Display:UpdateColors()
	--Display:UpdateNoteHeader()
	
	local DisplayEntryIndex = 1
	local NoteHeight = Padding
	LoadedNoteData = {}
	if Display.TestSequence then 
		local KeywordIndex = 1
		for i = 1,15 do 
			if (i + 2) == ceil((i + 2)/3)*3 then 
				if KeywordIndex%2 == 1 and AvyrRaidTools_DB.KeywordsCD[ceil(KeywordIndex/2)] then 
					insert(LoadedNoteData,{"T:"..(i*7)..":2.5","This entry contains a cooldown "..AvyrRaidTools_DB.KeywordsCD[ceil(KeywordIndex/2)].Term})
				elseif AvyrRaidTools_DB.Keywords[ceil(KeywordIndex/2)] then 
					insert(LoadedNoteData,{"T:"..(i*7)..":2.5","This entry contains a keyword ".. AvyrRaidTools_DB.Keywords[ceil(KeywordIndex/2)].Term})
				else
					insert(LoadedNoteData,{"T:"..(i*7)..":2.5","This is a test"})                    
				end
				KeywordIndex = KeywordIndex + 1
			else 
				insert(LoadedNoteData,{"T:"..(i*7)..":2.5","This is a test"})
			end
		end 
	elseif _ARTG.SV.GetVariable("CurrentNote") then 
		if _ARTG.SV.GetVariable("CurrentNote") and _ARTG.SV.GetVariable("CurrentNote").Data then 
			for i,v in ipairs(_ARTG.SV.GetVariable("CurrentNote").Data) do
				insert(LoadedNoteData,{v[1],v[2]})
			end
		end 
	end 
	for i,v in ipairs(LoadedNoteData) do 
		--local Cond,Note,Keyword = _ARTG.FormatEntryForDisplay(v,CurrentNote.CDs)
		local HeaderString  = _ARTG.SV.NoteEntry("Header","Summary",v[1])
		local NoteString,Keyword  = _ARTG.SV.NoteEntry("Note","DisplaySummary", v[2])
		if HeaderString and NoteString then --also ensures it is a valid entry with all required components
			if not NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex] then 
				NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex] = Widgets:CreateFrame(NoteDisplayWindow.Content)
			end
			NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]:Size(NoteDisplayWindow.ScrollFrame:GetWidth(),20)
			if DisplayEntryIndex > 1 then 
				NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]:SetPoint("TOPLEFT",NoteDisplayWindow["NoteEntry_"..(DisplayEntryIndex - 1)],"BOTTOMLEFT", 0,-Padding)
			else 
				NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]:SetPoint("TOPLEFT",0,-NoteHeight)
			end
			NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex].RealNoteEntryIndex = i --in case entries are skipped due to incomplete conditions
	
			if not NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["ConditionText"] then 
				NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["ConditionText"] = Widgets:FetchFontString(NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex])
				NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["ConditionText"]:SetPoint("TOPLEFT",Padding,-Padding)
				NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["ConditionText"]:SetPoint("TOPRIGHT",-Padding,-Padding)
				NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["ConditionText"]:SetJustifyH("LEFT")
				NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["ConditionText"]:SetTextColor(_ARTG.SV.GetVariable("ND_ConditionFontr"),_ARTG.SV.GetVariable("ND_ConditionFontg"),
				_ARTG.SV.GetVariable("ND_ConditionFontb"),_ARTG.SV.GetVariable("ND_ConditionFonta"))
			end 
			NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["ConditionText"]:SetText(HeaderString)
	
			if not NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["NoteText"] then 
				NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["NoteText"] = Widgets:FetchFontString(NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex])
				NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["NoteText"]:SetPoint("TOPLEFT", NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["ConditionText"],"BOTTOMLEFT")
				NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["NoteText"]:SetPoint("TOPRIGHT", NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["ConditionText"],"BOTTOMRIGHT")
				NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["NoteText"]:SetJustifyH("LEFT")
			end 
			NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["NoteText"]:SetText(NoteString)
	
			local StringHeight = NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["ConditionText"]:GetHeight() + NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]["NoteText"]:GetHeight() + 2*Padding
			if Keyword then 
				NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex].Keyword = Keyword 
			else 
				NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex].Keyword = nil 
			end 
			NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex].EntryHeight = StringHeight
			NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]:Size(nil, StringHeight)
			NoteHeight = NoteHeight + StringHeight + Padding
			DisplayEntryIndex = DisplayEntryIndex + 1
		end 
	end 
	NoteDisplayWindow.Content:Size(NoteDisplayWindow.ScrollFrame:GetWidth(),NoteHeight)
	Display:Reset()
	--Clean up
	while NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex] do 
		NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]:Release()
		NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex] = nil
		DisplayEntryIndex = DisplayEntryIndex + 1
	end 
	if _ARTG:CheckLoadConditions("Display") then 
		NoteDisplayWindow:Show()
	else 
		NoteDisplayWindow:Hide()
	end 
end 

Display.UpdateDimensions = function(self)
	if NoteDisplayWindow then 
		NoteDisplayWindow:Size(_ARTG.SV.GetVariable("ND_Width"),_ARTG.SV.GetVariable("ND_Height"))
		NoteDisplayWindow.Content:Size(_ARTG.SV.GetVariable("ND_Width"))
		local DisplayEntryIndex = 1
		while NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex] do 
			NoteDisplayWindow["NoteEntry_"..DisplayEntryIndex]:Size(_ARTG.SV.GetVariable("ND_Width") - 2*Padding)
			DisplayEntryIndex = DisplayEntryIndex + 1
		end 
	end 
end 

Display.ScrollToEntry = function(self, overWrite)
	local EntryIndex = 1
	if overWrite then 
		EntryIndex = overWrite
	elseif NoteDisplayWindow.Content:GetHeight() > NoteDisplayWindow.ScrollFrame:GetHeight() then 
		if CurrentIndex then 
			EntryIndex = CurrentIndex
		elseif NextIndex then 
			EntryIndex = NextIndex
		end 
	end 

	if EntryIndex > getn(LoadedNoteData) then 
		EntryIndex =  getn(LoadedNoteData)
	end 

	local offset = 0
	if NoteDisplayWindow["NoteEntry_"..EntryIndex] then 
		if NoteDisplayWindow["NoteEntry_"..(EntryIndex - 1)] then 
			local PrevHeight = NoteDisplayWindow["NoteEntry_"..EntryIndex]:GetHeight() + NoteDisplayWindow["NoteEntry_"..(EntryIndex - 1)]:GetHeight()
			if PrevHeight <= NoteDisplayWindow.ScrollFrame:GetHeight() then 
				offset = NoteDisplayWindow.Content:GetTop() - NoteDisplayWindow["NoteEntry_"..(EntryIndex - 1)]:GetTop() 
			else 
				offset = NoteDisplayWindow.Content:GetTop() - NoteDisplayWindow["NoteEntry_"..EntryIndex]:GetTop() 
			end 
		else 
			offset = NoteDisplayWindow.Content:GetTop() - NoteDisplayWindow["NoteEntry_"..EntryIndex]:GetTop() 
		end 
	end 

	if NoteDisplayWindow.ScrollFrame:GetVerticalScroll() == offset then 
		NoteDisplayWindow.Content:SetScript("OnUpdate",nil)
	elseif _ARTG.SV.GetVariable("ND_SmoothScroll") then 
		local offsetStartPos = NoteDisplayWindow.ScrollFrame:GetVerticalScroll()
		local offsetGrad = (offset - offsetStartPos)/_ARTG.SV.GetVariable("ND_TransitionTime")
		NoteDisplayWindow.Content:SetScript("OnUpdate",function(self, elapsed)
			offsetStartPos = offsetStartPos + offsetGrad*elapsed
			if (offsetGrad > 0 and offsetStartPos >= offset) or (offsetGrad < 0 and offsetStartPos <= offset) then 
				offsetStartPos = offset
				NoteDisplayWindow.ScrollFrame:SetVerticalScroll(offsetStartPos)
				self:SetScript("OnUpdate",nil)
			else
				NoteDisplayWindow.ScrollFrame:SetVerticalScroll(offsetStartPos)
			end 
		end)
	else 
		NoteDisplayWindow.Content:SetScript("OnUpdate",nil)
		NoteDisplayWindow.ScrollFrame:SetVerticalScroll(offset)
	end 
end 

local PlayerHpPool = {}
local HealthPool = 0
local HealthPoolNT = 0
local HealthPoolMax = 0
local HealthPoolMaxNT = 0
local EntryTriggerFrame = CreateFrame("FRAME")
local UntriggerTime = nil
local TriggerTime = nil
local NextTime = nil
local FirstCheckTrigger = nil
local TriggerTimeMax, TriggerTimeMin
local LastAbilityHit 

Display.CheckTriggerState = function(self)
	if NextIndex and LoadedNoteData[NextIndex] and LoadedNoteData[NextIndex][1] then 
		local EntryType,Time,ErrorMargin,AvgPercent,IgnoreTanks,UseTime = _ARTG.SV.NoteEntry("Header","Unpack",LoadedNoteData[NextIndex][1])
		if EntryType == "RH" then 
			if ((IgnoreTanks and AvgPercent >= 100*HealthPoolNT/HealthPoolMaxNT) 
			or (not IgnoreTanks and AvgPercent >= 100*HealthPool/HealthPoolMax))
			and _ARTG.EncounterTime >= TriggerTimeMin and (not TriggerTimeMax or _ARTG.EncounterTime <= TriggerTimeMax) then --check condition
				FirstCheckTrigger = nil 
				EntryTriggerFrame:SetScript("OnEvent",nil)
				Display:UpdateEntry("Trigger",NextIndex)
				NextTime = _ARTG.EncounterTime
			end 
		end 
	end 
end 

--Display:UpdateEntry("Next",CurrentIndex + 1) --start next (at the exact time of entry or the condition is met)
--Display:UpdateEntry("Trigger",CurrentIndex)  --trigger next to current (at the start of the timespan for timed entries or whenever the entry conditions are met)
--Display:UpdateEntry("Untrigger",CurrentIndex)  --untrigger next (end of time span or after 2.5 secs)
Display.UpdateEntry = function(self, Type, Index)
	if Index and NoteDisplayWindow then 
		if Type == "Next" then
			if NextIndex and NoteDisplayWindow["NoteEntry_"..NextIndex] and (not CurrentIndex or CurrentIndex ~= NextIndex) then 
				NoteDisplayWindow["NoteEntry_"..NextIndex]:SetColorBackdrop("Clear")
				Display:KeywordEntry(NoteDisplayWindow["NoteEntry_"..NextIndex])
			end 
			if NoteDisplayWindow["NoteEntry_"..Index] and LoadedNoteData[Index] and LoadedNoteData[Index][1] then 
				if _ARTG.SV.GetVariable("ND_HighlightNext") then 
					NoteDisplayWindow["NoteEntry_"..Index]:SetColorBackdrop("FULL_Backdrop",_ARTG.SV.GetVariable("ND_HighlightNextr"),_ARTG.SV.GetVariable("ND_HighlightNextg"),
					_ARTG.SV.GetVariable("ND_HighlightNextb"),_ARTG.SV.GetVariable("ND_HighlightNexta"))
				end 
				local EntryType,arg1,arg2,arg3,arg4,arg5,arg6 = _ARTG.SV.NoteEntry("Header","Unpack",LoadedNoteData[Index][1])
				--"T",Time,ErrorMargin
				if EntryType == "T" then 
					TriggerTime = arg1 - arg2
					NextTime = arg1
					EntryTriggerFrame:SetScript("OnEvent",nil)
					EntryTriggerFrame:UnregisterEvent("UNIT_HEALTH")
					EntryTriggerFrame:UnregisterEvent("UNIT_MAXHEALTH")	
					EntryTriggerFrame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
				elseif EntryType == "RH" then
					--"RH",Time,ErrorMargin,AvgPercent,IgnoreTanks,UseTime
					EntryTriggerFrame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
					TriggerTimeMin = _ARTG.EncounterTime + 5  --small grace period
					FirstCheckTrigger = TriggerTimeMin
					TriggerTimeMax = nil
					if arg5 then 
						if TriggerTimeMin < arg1 - arg2 then 
							TriggerTimeMin = arg1 - arg2
						end
						TriggerTimeMax = arg1 + arg2
					else 
						local subIndex = Index + 1
						while (LoadedNoteData[subIndex] and LoadedNoteData[subIndex][1]) do 
							local entryType,time,errorMargin,_,_,useTime = _ARTG.SV.NoteEntry("Header","Unpack",LoadedNoteData[subIndex][1])
							if (entryType == "T" or useTime) and time and errorMargin then 
								TriggerTimeMax = time - errorMargin
								break 
							end 
							subIndex = subIndex + 1
						end 
					end 
					NextTime = TriggerTimeMax
					HealthPool = 0
					HealthPoolNT = 0
					HealthPoolMax = 0
					HealthPoolMaxNT = 0
					for i,v in pairs(_ARTG.EncounterStats.EncounterRoosterByUnitID) do 
						v.MaxHealth =  UnitHealthMax(i)
						v.Health =  UnitHealth(i)
						HealthPool = HealthPool + v.Health
						HealthPoolMax = HealthPoolMax + v.MaxHealth
						if not v.Tank then 
							HealthPoolNT = HealthPoolNT + v.Health
							HealthPoolMaxNT = HealthPoolMaxNT + v.MaxHealth
						end
					end
					EntryTriggerFrame:SetScript("OnEvent",function(self,Event,UnitID)
						if _ARTG.EncounterStats.EncounterRoosterByUnitID[UnitID] then 
							if Event == "UNIT_MAXHEALTH" then --update max health stuff
								HealthPoolMax = HealthPoolMax - _ARTG.EncounterStats.EncounterRoosterByUnitID[UnitID].MaxHealth
								if not _ARTG.EncounterStats.EncounterRoosterByUnitID[UnitID].Tank then 
									HealthPoolMaxNT = HealthPoolMaxNT - _ARTG.EncounterStats.EncounterRoosterByUnitID[UnitID].MaxHealth
								end 
								_ARTG.EncounterStats.EncounterRoosterByUnitID[UnitID].MaxHealth = UnitHealthMax(UnitID)
								HealthPoolMax = HealthPoolMax + _ARTG.EncounterStats.EncounterRoosterByUnitID[UnitID].MaxHealth
								if not _ARTG.EncounterStats.EncounterRoosterByUnitID[UnitID].Tank then 
									HealthPoolMaxNT = HealthPoolMaxNT + _ARTG.EncounterStats.EncounterRoosterByUnitID[UnitID].MaxHealth
								end 
							end 
							HealthPool = HealthPool - _ARTG.EncounterStats.EncounterRoosterByUnitID[UnitID].Health
							if not _ARTG.EncounterStats.EncounterRoosterByUnitID[UnitID].Tank then 
								HealthPoolNT = HealthPoolNT - _ARTG.EncounterStats.EncounterRoosterByUnitID[UnitID].Health
							end 
							_ARTG.EncounterStats.EncounterRoosterByUnitID[UnitID].Health = UnitHealth(UnitID)
							HealthPool = HealthPool + _ARTG.EncounterStats.EncounterRoosterByUnitID[UnitID].Health
							if not _ARTG.EncounterStats.EncounterRoosterByUnitID[UnitID].Tank then 
								HealthPoolNT = HealthPoolNT + _ARTG.EncounterStats.EncounterRoosterByUnitID[UnitID].Health
							end 
							Display:CheckTriggerState()
						end 
					end)
					EntryTriggerFrame:RegisterEvent("UNIT_HEALTH")
					EntryTriggerFrame:RegisterEvent("UNIT_MAXHEALTH")	
				elseif EntryType == "A" then
					--"A",Time,ErrorMargin,SpellID,ExactMatch,UseTime,IgnoreDoT
					EntryTriggerFrame:UnregisterEvent("UNIT_HEALTH")
					EntryTriggerFrame:UnregisterEvent("UNIT_MAXHEALTH")	
					TriggerTimeMin = _ARTG.EncounterTime + 5  --small grace period
					TriggerTimeMax = nil
					if arg5 then 
						if TriggerTimeMin < arg1 - arg2 then 
							TriggerTimeMin = arg1 - arg2
						end
						TriggerTimeMax = arg1 + arg2
					else 
						local subIndex = Index + 1
						while (LoadedNoteData[subIndex] and LoadedNoteData[subIndex][1]) do 
							local entryType,time,errorMargin,_,_,useTime = _ARTG.SV.NoteEntry("Header","Unpack",LoadedNoteData[subIndex][1])
							if (entryType == "T" or useTime) and time and errorMargin then 
								TriggerTimeMax = time - errorMargin
								break 
							end 
							subIndex = subIndex + 1
						end 
					end 
					NextTime = TriggerTimeMax

					EntryTriggerFrame:SetScript("OnEvent",function()
						local arg = {CombatLogGetCurrentEventInfo()}
						if (arg[2] == "RANGE_DAMAGE" or arg[2] == "SPELL_DAMAGE" or (not arg6 and arg[2] == "SPELL_PERIODIC_DAMAGE") or arg[2] == "SPELL_BUILDING_DAMAGE") and 
						((arg4 and arg[12] == arg3) or 
						(not arg4 and arg[13] == GetSpellInfo(arg3)))  
						and _ARTG.EncounterTime >= TriggerTimeMin and (not TriggerTimeMax or _ARTG.EncounterTime <= TriggerTimeMax) then 
							EntryTriggerFrame:SetScript("OnEvent",nil)
							Display:UpdateEntry("Trigger",NextIndex)
							NextTime = _ARTG.EncounterTime
						end
					end)
					EntryTriggerFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
				end 
			end
			NextIndex = Index
		elseif Type == "Trigger" then  
			if CurrentIndex and NoteDisplayWindow["NoteEntry_"..CurrentIndex] then 
				NoteDisplayWindow["NoteEntry_"..CurrentIndex]:SetColorBackdrop("Clear")
				Display:KeywordEntry(NoteDisplayWindow["NoteEntry_"..CurrentIndex])
			end 
			if NoteDisplayWindow["NoteEntry_"..Index] and LoadedNoteData[Index] and LoadedNoteData[Index][1] then 
				if _ARTG.SV.GetVariable("ND_HighlightCurrent") then 
					NoteDisplayWindow["NoteEntry_"..Index]:SetColorBackdrop("FULL_Backdrop",_ARTG.SV.GetVariable("ND_HighlightCurrentr"),_ARTG.SV.GetVariable("ND_HighlightCurrentg"),
					_ARTG.SV.GetVariable("ND_HighlightCurrentb"),_ARTG.SV.GetVariable("ND_HighlightCurrenta"))
				end 

				if NoteDisplayWindow["NoteEntry_"..Index].Keyword and _ARTG.SV.GetVariable("ND_EnableSound") then 
					if type(NoteDisplayWindow["NoteEntry_"..Index].Keyword) == "number" or type(NoteDisplayWindow["NoteEntry_"..Index].Keyword) == "string" then 
						_ARTG.DataFuncs.Sounds("sound.play",NoteDisplayWindow["NoteEntry_"..Index].Keyword)
					elseif _ARTG.SV.GetVariable("ND_BaseSound") then 
						_ARTG.DataFuncs.Sounds("sound.play",_ARTG.SV.GetVariable("ND_BaseSound"))
					end 
				end 
 
				local EntryType,arg1,arg2,arg3,arg4,arg5,arg6 = _ARTG.SV.NoteEntry("Header","Unpack",LoadedNoteData[Index][1])
				UntriggerTime = (arg1 or _ARTG.EncounterTime) + (arg2 or 2.5)
			end 
			CurrentIndex = Index
		elseif Type == "Untrigger" then 
			if CurrentIndex and NoteDisplayWindow["NoteEntry_"..CurrentIndex] then 
				NoteDisplayWindow["NoteEntry_"..CurrentIndex]:SetColorBackdrop("Clear")
				Display:KeywordEntry(NoteDisplayWindow["NoteEntry_"..CurrentIndex])
			end 

			UntriggerTime = nil
			CurrentIndex = nil
		end
		Display:ScrollToEntry()
	end 
end 


Display.Reset = function(self, Start)
	EntryTriggerFrame:SetScript("OnUpdate",nil)
	EntryTriggerFrame:SetScript("OnEvent",nil)
	UntriggerTime = nil
	TriggerTime = nil
	NextTime = nil
	EntryTriggerFrame:UnregisterEvent("UNIT_HEALTH")
	EntryTriggerFrame:UnregisterEvent("UNIT_MAXHEALTH")	
	EntryTriggerFrame:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	local index = 1
	if NoteDisplayWindow then 
		while NoteDisplayWindow["NoteEntry_"..index] do 
			Display:KeywordEntry(NoteDisplayWindow["NoteEntry_"..index])
			index = index + 1
		end 
	end 
	NextIndex = nil
	CurrentIndex = nil
	if Start then 
		Display:UpdateEntry("Next",1)
	else 
		Display:ScrollToEntry(1)
	end 
end 

Display.Start = function(self, TestSequence)

end 

Display.OnUpdate = function(encounterTime)
	if LoadedNoteData and NoteDisplayWindow then
		if encounterTime == 0 then 
			Display:Load()
			Display:Reset(true)
			Display.CombatLock = true 
		end 
		if TriggerTime and encounterTime >= TriggerTime then --entry triggered        
			TriggerTime = nil            
			Display:UpdateEntry("Trigger",NextIndex)
		end 
		if UntriggerTime and encounterTime >= UntriggerTime then --entry untriggered   
			UntriggerTime = nil            
			Display:UpdateEntry("Untrigger",CurrentIndex)
		end 
		if NextTime and encounterTime >= NextTime then 
			NextTime = nil 
			Display:UpdateEntry("Next",NextIndex + 1)
		end 
		if FirstCheckTrigger and encounterTime >= FirstCheckTrigger then 
			Display:CheckTriggerState()
		end 
	end
end


Display.Stop = function(self, TestSequence)
	if TestSequence and not Display.CombatLock and Display.TestSequence then 
		Display.TestSequence = false 
		Display:Load()
	elseif not TestSequence then 
		Display.CombatLock = false
	end 
end 

Display.UpdatePosition = function(self)
	if NoteDisplayWindow and not NoteDisplayWindow.Released then
		NoteDisplayWindow:SetScale(_ARTG.SV.GetVariable("ND_Scale") or NoteDisplayWindow:GetScale())
		local Scale = NoteDisplayWindow:GetEffectiveScale()
		NoteDisplayWindow:SetPoint("CENTER",(_ARTG.SV.GetVariable("ND_PosX") or 0)/Scale,(_ARTG.SV.GetVariable("ND_PosY") or 0)/Scale)
		NoteDisplayWindow:MakeMovable(not _ARTG.SV.GetVariable("ND_Locked"))
	end 
end 

Display.UpdateColors = function(self)
	if NoteDisplayWindow then 
		if _ARTG.SV.GetVariable("ND_Backdrop") then 
			NoteDisplayWindow:SetColorBackdrop("ALL",_ARTG.SV.GetVariable("ND_Backdropr"),_ARTG.SV.GetVariable("ND_Backdropg"),
			_ARTG.SV.GetVariable("ND_Backdropb"),_ARTG.SV.GetVariable("ND_Backdropa"))
			--[[
			if NoteDisplayWindow.NoteHeader then 
				NoteDisplayWindow.NoteHeader:SetColorBackdrop("ALL",_ARTG.SV.GetVariable("ND_Backdropr"),_ARTG.SV.GetVariable("ND_Backdropg"),
				_ARTG.SV.GetVariable("ND_Backdropb"),_ARTG.SV.GetVariable("ND_Backdropa"))
			end ]]
		else 
			NoteDisplayWindow:SetColorBackdrop("Clear")  
			--[[     
			if NoteDisplayWindow.NoteHeader then 
				NoteDisplayWindow.NoteHeader:SetColorBackdrop("Clear")   
			end ]]
		end 
		local Index = 1
		while NoteDisplayWindow["NoteEntry_"..Index] do 
			if NoteDisplayWindow["NoteEntry_"..Index].ConditionText then 
				NoteDisplayWindow["NoteEntry_"..Index].ConditionText:SetTextColor(_ARTG.SV.GetVariable("ND_ConditionFontr"),_ARTG.SV.GetVariable("ND_ConditionFontg"),
				_ARTG.SV.GetVariable("ND_ConditionFontb"),_ARTG.SV.GetVariable("ND_ConditionFonta"))
			end 
			if NoteDisplayWindow["NoteEntry_"..Index].NoteText then 
				NoteDisplayWindow["NoteEntry_"..Index].NoteText:SetTextColor(_ARTG.SV.GetVariable("ND_NoteFontr"),_ARTG.SV.GetVariable("ND_NoteFontg"),
				_ARTG.SV.GetVariable("ND_NoteFontb"),_ARTG.SV.GetVariable("ND_NoteFonta"))
			end 
			Index = Index + 1
		end 
		if CurrentIndex and NoteDisplayWindow["NoteEntry_"..CurrentIndex] then
			if _ARTG.SV.GetVariable("ND_HighlightCurrent") then 
				NoteDisplayWindow["NoteEntry_"..CurrentIndex]:SetColorBackdrop("FULL_Backdrop",_ARTG.SV.GetVariable("ND_HighlightCurrentr"),_ARTG.SV.GetVariable("ND_HighlightCurrentg"),
				_ARTG.SV.GetVariable("ND_HighlightCurrentb"),_ARTG.SV.GetVariable("ND_HighlightCurrenta"))
			else 
				NoteDisplayWindow["NoteEntry_"..CurrentIndex]:SetColorBackdrop("Clear")
				Display:KeywordEntry(NoteDisplayWindow["NoteEntry_"..CurrentIndex])
			end 
		end 
		if NextIndex and NoteDisplayWindow["NoteEntry_"..NextIndex] then 
			if _ARTG.SV.GetVariable("ND_HighlightNext") then 
				NoteDisplayWindow["NoteEntry_"..NextIndex]:SetColorBackdrop("FULL_Backdrop",_ARTG.SV.GetVariable("ND_HighlightNextr"),_ARTG.SV.GetVariable("ND_HighlightNextg"),
				_ARTG.SV.GetVariable("ND_HighlightNextb"),_ARTG.SV.GetVariable("ND_HighlightNexta"))
			else
				NoteDisplayWindow["NoteEntry_"..NextIndex]:SetColorBackdrop("Clear")
				Display:KeywordEntry(NoteDisplayWindow["NoteEntry_"..NextIndex])
			end 
		end 
	end 
end 

Display.UpdateKeywords = function(self, ScanAgain)
	if ScanAgain then 
		local Index = 1
		while NoteDisplayWindow["NoteEntry_"..Index] do 
			local NoteString,Keyword  = _ARTG.SV.NoteEntry("Note","DisplaySummary", LoadedNoteData[NoteDisplayWindow["NoteEntry_"..Index].RealNoteEntryIndex][1])
			if Keyword ~= NoteDisplayWindow["NoteEntry_"..Index].Keyword then 
				NoteDisplayWindow["NoteEntry_"..Index].Keyword = Keyword
			end 
			Display:KeywordEntry(NoteDisplayWindow["NoteEntry_"..Index])
			Index = Index + 1
		end 
	else     
		local Index = 1
		while NoteDisplayWindow["NoteEntry_"..Index] do 
			Display:KeywordEntry(NoteDisplayWindow["NoteEntry_"..Index])
			Index = Index + 1
		end 
	end 
end 

Display.KeywordEntry = function(self, Entry)
	if _ARTG.SV.GetVariable("ND_EnableKeywords") and _ARTG.SV.GetVariable("ND_KeywordsBorderHighlight") and Entry.Keyword then 
		Entry:SetColorBackdrop("Border",
		_ARTG.SV.GetVariable("ND_KeywordsBorderHighlightr"),_ARTG.SV.GetVariable("ND_KeywordsBorderHighlightg"),_ARTG.SV.GetVariable("ND_KeywordsBorderHighlightb"),_ARTG.SV.GetVariable("ND_KeywordsBorderHighlighta"),
		_ARTG.SV.GetVariable("ND_KeywordsBorderHighlightr"),_ARTG.SV.GetVariable("ND_KeywordsBorderHighlightg"),_ARTG.SV.GetVariable("ND_KeywordsBorderHighlightb"),_ARTG.SV.GetVariable("ND_KeywordsBorderHighlighta"))
	else 
		Entry:SetColorBackdrop("Clear")
	end 
	if _ARTG.SV.GetVariable("ND_EnableKeywords") and _ARTG.SV.GetVariable("ND_KeywordsFontHighlight") and Entry.Keyword then
		Entry["NoteText"]:SetTextColor(_ARTG.SV.GetVariable("ND_KeywordsFontHighlightr"),_ARTG.SV.GetVariable("ND_KeywordsFontHighlightg"),_ARTG.SV.GetVariable("ND_KeywordsFontHighlightb"),_ARTG.SV.GetVariable("ND_KeywordsFontHighlighta"))
	else		
		Entry["NoteText"]:SetTextColor(_ARTG.SV.GetVariable("ND_NoteFontr"),_ARTG.SV.GetVariable("ND_NoteFontg"),_ARTG.SV.GetVariable("ND_NoteFontb"),_ARTG.SV.GetVariable("ND_NoteFonta"))
	end
	if _ARTG.SV.GetVariable("ND_EnableKeywords") and _ARTG.SV.GetVariable("ND_HideEntriesWithoutKeywords") and not Entry.Keyword then 
		Entry:Size(nil, 0.000000001)
		Entry:Hide()
	else 
		Entry:Size(nil, Entry.EntryHeight)		
		Entry:Show();
	end
end 

local LoadNotePopup
local popupDisplayTime = 0
local popupDisplayStartFadeTime = 3
local popupDisplayFadeTime = 1.5
Display.CallLoadNotePopup = function(Action,...)
	if LoadNotePopup then 
		LoadNotePopup:Release()
		LoadNotePopup = nil
	end
	if Action:find("show") and not IsEncounterInProgress() then 
		LoadNotePopup = Widgets:CreateFrame(UIParent)
		LoadNotePopup:SetFrameStrata("HIGH")
		LoadNotePopup:SetThemedBackdrop()
	
		local Scale = LoadNotePopup:GetEffectiveScale()
		LoadNotePopup:SetPoint("CENTER",(_ARTG.SV.GetVariable("ND_PosX") or 0)/Scale,(_ARTG.SV.GetVariable("ND_PosY") or 0)/Scale)
		LoadNotePopup:Size(200,200)

		if Action:find(".boss") then 
			local bossID,raidID,expansionIndex = ...
			LoadNotePopup:SetText(_ARTG.DataFuncs.GetRaidInfo("boss.data.name",bossID),nil,nil,nil,nil,nil,"TOP")

			LoadNotePopup.NoteList = Widgets:CreateContainer(LoadNotePopup)
			LoadNotePopup.NoteList:SetThemedBackdrop()

			LoadNotePopup.NoteList:SetPoint("TOPLEFT",Padding + BorderSize,-20)
			LoadNotePopup.NoteList:Size(200 - 2*Padding - 2*BorderSize,140 - 3*Padding - BorderSize)

			if AvyrRaidTools_DB.Notes[expansionIndex] and AvyrRaidTools_DB.Notes[expansionIndex][raidID] and AvyrRaidTools_DB.Notes[expansionIndex][raidID][bossID] then 
				for i,v in ipairs(AvyrRaidTools_DB.Notes[expansionIndex][raidID][bossID]) do 
					LoadNotePopup.NoteList:AddRow("Type","DB","Text",v.Name,"Func",function()
						_ARTG.DataFuncs.NoteData("current.set",v,expansionIndex,raidID,bossID)
						LoadNotePopup:Release()
						LoadNotePopup = nil
					end,"Type","DB","Icon","Interface\\GossipFrame\\ChatBubbleGossipIcon.blp","FixedWidth",20,"Func",function()
						_ARTG.Coms.Send("Prepare",v.Name,expansionIndex,raidID,bossID,i)
					end)
				end
			end

			LoadNotePopup.NewNoteBtn = Widgets:CreateButton(LoadNotePopup)
			LoadNotePopup.NewNoteBtn:Size(200 - 2*Padding - 2*BorderSize,20)
			LoadNotePopup.NewNoteBtn:SetPoint("TOPLEFT",LoadNotePopup.NoteList,"BOTTOMLEFT",0,-Padding)
			LoadNotePopup.NewNoteBtn:SetText(Loc:Translation("NEW_NOTE"))
			LoadNotePopup.NewNoteBtn.OnClick = function()
				_ARTG.Editor:NoteInfoEdit(Loc:Translation("NEW_NOTE"),"",expansionIndex,raidID,bossID,function(Name,Description,Expansion,Raid,Boss)
					_ARTG.Editor:EditNote("New",Name,Description,nil,Expansion,Raid,Boss)
					_ARTG.Editor:Call("Open")
				end)
			end

			LoadNotePopup.CloseBtn = Widgets:CreateButton(LoadNotePopup)
			LoadNotePopup.CloseBtn:Size(200 - 2*Padding - 2*BorderSize,20)
			LoadNotePopup.CloseBtn:SetPoint("TOPLEFT",LoadNotePopup.NewNoteBtn,"BOTTOMLEFT",0,-Padding)
			LoadNotePopup.CloseBtn:SetText(Loc:Translation("CLOSE"))
			LoadNotePopup.CloseBtn.OnClick = function()
				LoadNotePopup:Release()
				LoadNotePopup = nil
			end


			popupDisplayTime = 0
			LoadNotePopup:SetScript("OnUpdate",function(self,elapsed)
				if MouseIsOver(self) then 
					popupDisplayTime = 0   
					LoadNotePopup:SetAlpha(1)
				else 
					popupDisplayTime = popupDisplayTime + elapsed
					if popupDisplayTime > (popupDisplayStartFadeTime + popupDisplayFadeTime) then 
						LoadNotePopup:Release()
						LoadNotePopup = nil
					elseif popupDisplayTime > popupDisplayStartFadeTime then 
						LoadNotePopup:SetAlpha(1 - (popupDisplayTime - popupDisplayStartFadeTime)/popupDisplayFadeTime)
					end
				end
			end)
		end 
	else 
		return nil 
	end
end
