local MouseIsOver, insert = MouseIsOver, table.insert;

local function SetSelect(btn,Select)
    if type(Select) ~= "number" then 
        Select = nil 
    end

    if Select ~= btn.Selected then 
        btn.Selected = Select

        if btn.OnSelect then 
            btn:OnSelect(Select)
        end 
        
        btn:RefreshItems()
    end 
end 

local function AddItems(btn,HeaderType,Header,Data)
    btn.HeaderBtn:SetText(Header,nil,"Highlight",nil,nil,"LEFT")
    btn.HeaderType = HeaderType
    btn.DataSource = Data
    btn.Selected = nil
    btn:RefreshItems()
end

local function RefreshItems(btn,Select)
    local Index = 1
    while btn["SubCategoryBtn"..Index] do
        btn["SubCategoryBtn"..Index]:Release() 
        btn["SubCategoryBtn"..Index] = nil
        Index = Index + 1
    end 
    if btn.HeaderType == "Selectable" then 
        btn.HeaderBtn:SetFocus(btn.Selected)
    end 
    if btn.Selected and btn.DataSource then 
        for i,v in ipairs(btn.DataSource) do 
            if v[2] == "Selectable" then 
                btn["SubCategoryBtn"..i] = btn.self:CreateButton(btn,true)
                btn["SubCategoryBtn"..i]:Size(btn:GetWidth() - 2*btn.self.Padding - 2*btn.self.BorderSize,20)
                btn["SubCategoryBtn"..i]:SetText(v[1],nil,"Normal",nil,nil,"LEFT")
                btn["SubCategoryBtn"..i]:SetPoint("TOPLEFT",btn.HeaderBtn,"BOTTOMLEFT",20+btn.self.BorderSize,-(i - 1)*20)
                btn["SubCategoryBtn"..i]:SetPoint("TOPRIGHT",btn.HeaderBtn,"BOTTOMRIGHT",-btn.self.BorderSize,-(i - 1)*20)
                btn["SubCategoryBtn"..i]:SetFocus(i == btn.Selected)
                btn["SubCategoryBtn"..i].OnClick = function(self)
                    btn:SetSelect(i)
                end
            end
        end 
    end 
    btn:Size(nil,1)
end

function _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin:CreateCategorySelect(Parent,Borderless)
    local Button = self:CreateFrame(Parent)
    if not Borderless then 
        Button:SetThemedBackdrop()
    end 

    Button.SetSelect = SetSelect
    Button.AddItems = AddItems
    Button.RefreshItems = RefreshItems

    Button.HeaderBtn = self:CreateButton(Button,Borderless)
    Button.HeaderBtn:SetPoint("TOPLEFT")
    Button.HeaderBtn:SetPoint("TOPRIGHT")
    Button.HeaderBtn:Size(nil,20)

    Button.HeaderBtn.OnClick = function()
        Button:SetSelect(type(Button.Selected) == "nil" and 0 or nil)
    end 

    Button:SizeChanged(function()
        local Height = 20
        if Button.Selected and Button.DataSource then 
            Height = Height + getn(Button.DataSource)*20
            Height = Height + self.BorderSize 
        end 
        if abs(Height - Button:GetHeight()) > 2 then 
            Button:Size(nil,Height)
        end
    end)

    return Button
end
